﻿<div class="filters">
    <select id="Category" class="form-control filter">
        <option value="0">@Resources.Actions.ChooseCategory</option>
        @foreach (var s in ViewBag.Categories)
        {
            <option @(ViewBag.CategoryId == s.Id ? "selected='selected'" : "") value="@s.Id">@s.Name</option>
        }
    </select>
    <a href="@Url.Action("FunctionEdit")?categoryId=@ViewBag.CategoryId" class="btn btn-success" onclick="return showModal(this)">@Html.Raw(Resources.Actions.Add)</a>
</div>
<table class="table table-striped table-bordered table-short">
    <thead>
        <tr>
            <th>@Resources.Actions.TT</th>
            <th>@Resources.Actions.Icon</th>
            <th>@Resources.Actions.Name</th>
            <th>@Resources.Actions.Key</th>
            <th>@Resources.Actions.IsAdmin</th>
            <th>@Resources.Actions.Url</th>
            <th class="text-center w50"><i class="fa fa-pencil" aria-hidden="true"></i></th>
            <th class="text-center w50"><i class="fa fa-trash" aria-hidden="true"></i></th>
        </tr>
    </thead>
    <tbody></tbody>
</table>

<script>
    $(function () {
        $(".filter").change(function () {
            window.location.href = `@Url.Action("Function")?categoryId=${$("#Category").val()}`;
        });
        var t = $('table.table').DataTable(
        {
            processing: true,
            serverSide: true,
            drawCallback: function () { hidePageLoading(); setTimeout(function () { t.ajax.reload(null, false); }, 60000); },
            filter: false,
            orderMulti: false, 
            pageLength: 30,
            iDisplayLength: 30,
            aLengthMenu: [[30, 50, 100, 200, 500, 1000,  2000, 5000], [30, 50, 100, 200, 500, 1000, 2000, 5000]],
            order: [[1, "asc"]],
            dom: '<"top"f>rt<"bottom"ilp><"clear">',
            ajax: { url: '@Url.Action("GetFunction")?categoryId=@ViewBag.CategoryId', type: "GET", contentType: "application/json", beforeSend : function() { showPageLoading(); } },
            columns: [
                {
                    "data": "Id",
                    "className": "text-center",
                    "bSortable": false,
                    "width": "50px"
                },
                {
                    "data": "Icon",
                    "bSortable": false,
                    "className": "text-center"
                },
                {
                    "data": "Name",
                    "bSortable": false
                },
                {
                    "data": "Key",
                    "bSortable": false
                },
                {
                    "data": "IsAdmin",
                    "bSortable": false,
                    "className": "text-center",
                    render: function(d) {
                        return d ? "<i class='fa fa-check'></i>" : "";
                    }
                },
                {
                    "data": "Url",
                    "bSortable": false
                },
                {
                    "data": "Id",
                    "bSortable": false,
                    "className": "text-center",
                    "render": function (data) {
                        return `<a class="ids" id="${data}" href="@Url.Action("FunctionEdit")?id=${data}" onclick="return showModal(this)"><i class="fa fa-pencil" aria-hidden="true"></i></a>`;
                    }
                },
                {
                    "data": "Id",
                    "bSortable": false,
                    "className": "text-center",
                    "render": function (data) {
                        return `<a href="@Url.Action("FunctionDelete")?id=${data}" onclick="@Html.Raw(Resources.Actions.Confirm)"><i class="fa fa-trash" aria-hidden="true"></i></a>`;
                    }
                }
            ],
            "initComplete": function () {
                $(".table-short tbody").sortable({
                    update: function () {
                        $(".ids").each(function () {
                            $(this).parent().parent().attr("id", $(this).attr("id"));
                        });
                        $.post("@Url.Action("FunctionSort")", { Ids: $(this).sortable("toArray") }).done(function () {
                            t.ajax.reload(null, false);
                        });
                    }
                });
            }
        });
        t.on('draw.dt',
                function () {
                    t.column(0, { search: 'applied', order: 'applied' })
                        .nodes()
                        .each(function (cell, i) {
                            cell.innerHTML = i + 1;
                        });
                })
            .draw();
        setModalCompletedCallback(function () {
            t.ajax.reload(null, false);
        });
    });
</script>